import { EnumerationParameterType, ParameterLocation, ParameterType, RegexParameterType, RouteParameter, StringParameterType } from './types';
import { ZodObject } from 'zod';
import { ZodType } from 'zod';
export declare function convertParams(field: any, params: any): ZodType;
export declare class Arr {
    static generator: boolean;
    constructor(innerType: any, params?: ParameterType);
}
export declare class Obj {
    static generator: boolean;
    constructor(fields: object, params?: ParameterType);
}
export declare class Num {
    static generator: boolean;
    constructor(params?: ParameterType);
}
export declare class Int {
    static generator: boolean;
    constructor(params?: ParameterType);
}
export declare class Str {
    static generator: boolean;
    constructor(params?: StringParameterType);
}
export declare class DateTime {
    static generator: boolean;
    constructor(params?: ParameterType);
}
export declare class Regex {
    static generator: boolean;
    constructor(params: RegexParameterType);
}
export declare class Email {
    static generator: boolean;
    constructor(params?: ParameterType);
}
export declare class Uuid {
    static generator: boolean;
    constructor(params?: ParameterType);
}
export declare class Hostname {
    static generator: boolean;
    constructor(params?: ParameterType);
}
export declare class Ipv4 {
    static generator: boolean;
    constructor(params?: ParameterType);
}
export declare class Ipv6 {
    static generator: boolean;
    constructor(params?: ParameterType);
}
export declare class DateOnly {
    static generator: boolean;
    constructor(params?: ParameterType);
}
export declare class Bool {
    static generator: boolean;
    constructor(params?: ParameterType);
}
export declare class Enumeration {
    static generator: boolean;
    constructor(params: EnumerationParameterType);
}
export declare function Query(type: any, params?: ParameterLocation): RouteParameter;
export declare function Path(type: any, params?: ParameterLocation): RouteParameter;
export declare function Header(type: any, params?: ParameterLocation): RouteParameter;
export declare function extractParameter(request: Request, query: Record<string, any>, name: string, location: string): any;
export declare function extractQueryParameters(request: Request, schema?: ZodObject<any>): Record<string, any> | null;
